package org.drools.cep;

import org.drools.modelcompiler.dsl.pattern.D;
import org.drools.model.Index.ConstraintType;
import org.kie.hacep.sample.kjar.StockTickEvent;
import java.util.UUID;
import org.kie.remote.DroolsExecutor;
import org.kie.hacep.sample.kjar.Result;
import static org.drools.cep.RulesE14EC3ED2BC2CCD297994E2562E9A6BE.*;

public class RulesE14EC3ED2BC2CCD297994E2562E9A6BERuleMethods0 {

    /**
     * Rule name: StockAverage
     */
    public static org.drools.model.Rule rule_StockAverage() {
        final org.drools.model.Variable<org.kie.hacep.sample.kjar.Result> var_$r = D.declarationOf(org.kie.hacep.sample.kjar.Result.class,
                                                                                                   DomainClassesMetadataE14EC3ED2BC2CCD297994E2562E9A6BE.org_kie_hacep_sample_kjar_Result_Metadata_INSTANCE,
                                                                                                   "$r");
        final org.drools.model.Variable<java.lang.String> var_$name = D.declarationOf(java.lang.String.class,
                                                                                      DomainClassesMetadataE14EC3ED2BC2CCD297994E2562E9A6BE.java_lang_String_Metadata_INSTANCE,
                                                                                      "$name");
        final org.drools.model.Variable<org.kie.hacep.sample.kjar.StockTickEvent> var_GENERATED_$pattern_StockTickEvent$1$ = D.declarationOf(org.kie.hacep.sample.kjar.StockTickEvent.class,
                                                                                                                                             DomainClassesMetadataE14EC3ED2BC2CCD297994E2562E9A6BE.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE,
                                                                                                                                             "GENERATED_$pattern_StockTickEvent$1$");
        final org.drools.model.Variable<Double> var_$p = D.declarationOf(Double.class,
                                                                         "$p");
        final org.drools.model.Variable<java.lang.Double> var_$avg = D.declarationOf(java.lang.Double.class,
                                                                                     DomainClassesMetadataE14EC3ED2BC2CCD297994E2562E9A6BE.java_lang_Double_Metadata_INSTANCE,
                                                                                     "$avg");
        org.drools.model.Rule rule = D.rule("org.drools.cep",
                                            "StockAverage").build(D.pattern(var_$r).bind(var_$name,
                                                                                         org.drools.cep.PD1.LambdaExtractorD14787FE5938CB60736F74C0268A0125.INSTANCE,
                                                                                         D.reactOn("stockName")),
                                                                  D.accumulate(D.pattern(var_GENERATED_$pattern_StockTickEvent$1$).expr("E44016C0D11BC5C44AC48D88E9FD4D6A",
                                                                                                                                        var_$name,
                                                                                                                                        org.drools.cep.P38.LambdaPredicate389278087EF5ABF0446826348294DB9E.INSTANCE,
                                                                                                                                        D.betaIndexedBy(java.lang.String.class,
                                                                                                                                                        org.drools.model.Index.ConstraintType.EQUAL,
                                                                                                                                                        DomainClassesMetadataE14EC3ED2BC2CCD297994E2562E9A6BE.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE.getPropertyIndex("company"),
                                                                                                                                                        org.drools.cep.P3E.LambdaExtractor3E6754AF4A2737D540A562E7EED5BAE7.INSTANCE,
                                                                                                                                                        org.drools.cep.P04.LambdaExtractor04ED9FB6BBAD36E4E9B2945820EFFBBF.INSTANCE),
                                                                                                                                        D.reactOn("company")).bind(var_$p,
                                                                                                                                                                   org.drools.cep.P38.LambdaExtractor3862A9AD736DBB4DA63A5736328649CC.INSTANCE,
                                                                                                                                                                   D.reactOn("price")),
                                                                               D.accFunction(org.drools.core.base.accumulators.AverageAccumulateFunction::new,
                                                                                             var_$p).as(var_$avg)),
                                                                  D.on(var_$name,
                                                                       var_$r,
                                                                       var_$avg).execute(org.drools.cep.P96.LambdaConsequence961A4802FE0419775ABAF3710D6D4C71.INSTANCE));
        return rule;
    }

    /**
     * Rule name: StockLog
     */
    public static org.drools.model.Rule rule_StockLog() {
        final org.drools.model.Variable<org.kie.hacep.sample.kjar.StockTickEvent> var_$stock = D.declarationOf(org.kie.hacep.sample.kjar.StockTickEvent.class,
                                                                                                               DomainClassesMetadataE14EC3ED2BC2CCD297994E2562E9A6BE.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE,
                                                                                                               "$stock");
        org.drools.model.Rule rule = D.rule("org.drools.cep",
                                            "StockLog").build(D.pattern(var_$stock),
                                                              D.on(var_$stock).execute(org.drools.cep.P8E.LambdaConsequence8ED954220B4486412DDF07907205BEA4.INSTANCE));
        return rule;
    }
}
